/*
 File: o2_sdc.h
 Date and Time: Fri Oct 24 08:20:24 2014 
*/
#ifndef __o2_sdc_h__
#define __o2_sdc_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "cweb_or_c_k.h"
#include "c_string.h"
#include "c_literal.h"
#include "o2_code_end.h"
extern char PRT_SW;
  
extern yacco2::Thread_entry ITH_o2_sdc;

extern yacco2::State S1_Co2_sdc;
namespace NS_o2_sdc {
yacco2::THR _YACCO2_CALL_TYPE
TH_o2_sdc(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_o2_sdc(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[3];
};
class Co2_sdc: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Ryacco2_syntax_code_ = 569//start_of_rule_list + 0
    ,rhs1_Ryacco2_syntax_code_ = 1
   ,R_Rchrs_ = 570//start_of_rule_list + 2
    ,rhs1_Rchrs_ = 2
    ,rhs2_Rchrs_ = 3
   ,R_Rchr_ = 571//start_of_rule_list + 4
    ,rhs1_Rchr_ = 4
    ,rhs2_Rchr_ = 5
    ,rhs3_Rchr_ = 6
    ,rhs4_Rchr_ = 7
    ,rhs5_Rchr_ = 8
    ,rhs6_Rchr_ = 9
    ,rhs7_Rchr_ = 10
  };
  //no of la sets = 2
  //no of states = 12
  Co2_sdc();
  ~Co2_sdc();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[11];
  
    public: 
    char ddd_[1024*32];
    int ddd_idx_;
    void copy_str_into_buffer(std::string* Str);
    void copy_kstr_into_buffer(const char* Str);
  
 };
struct Ryacco2_syntax_code;
struct Rchrs;
struct Rchr;
struct Ryacco2_syntax_code:public yacco2::CAbs_lr1_sym {
  Ryacco2_syntax_code(yacco2::Parser* P);
  void op();
  public:
};

struct Rchrs:public yacco2::CAbs_lr1_sym {
  Rchrs(yacco2::Parser* P);
  public:
};

struct Rchr:public yacco2::CAbs_lr1_sym {
  Rchr(yacco2::Parser* P);
  void op();
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
};

} // end of namespace

#endif
